<template>
  <v-container>
    <base-material-search-screen
      style="width: 100%"
      title="QUẢN LÝ KHO HÀNG"
      text1="BÁN HÀNG"
      :disabled1="true"
      :disabled2="!isMobile()"
      :disabled3="(this.selected == undefined || this.selected == null || this.selected.length <= 0) && !isMobile()"
      text2="Xóa"
      text3="CẬP NHẬT TRẠNG THÁI"
      @action-1="createOrder()"
      @action-2="confirmDeleteOrder()"
      @action-3="updateOrder()"
    >
      <v-tabs
        v-model="tab"
        show-arrows
        background-color="grey pa-0 ma-0"
        class="pl-0"
        dark
        grow
        active-class="teal"
        slider-color="blue"
        :scrollable="false"
        @change="onTabChange"
      >
        <!-- <v-tabs-slider color="cyan darken-4"></v-tabs-slider> -->
        <v-tab
          v-for="(tab, idx) in tabs"
          :key="tab.index"
          ripple
          class="pa-0 ma-0"
          :disabled="tab.disabled"
        >
          <v-icon medium>
            {{ tab.icon }}
          </v-icon>
          <div class="caption py-1 pa-1">
            {{ tab.title }}
          </div>
        </v-tab>
        <v-tab-item class="tab-item-list" />
        <v-tabs-items
          v-model="tab"
          touchless
          class=" pa-0 ma-0"
        >
          <v-tab-item class="tab-item-list">
            <v-row v-if="!isMobile()">
              <v-col class="mt-0 pt-1">
                <v-data-table
                  v-model="selected"
                  :headers="headers"
                  :items="orderList"
                  :single-select="singleSelect"
                  :search="search"
                  class="elevation-1 table-list"
                  show-select
                  fixed-header
                  height="510"
                >
                  <!-- Search -->
                  <template v-slot:top>
                    <v-row class="ml-1 mr-1 ">
                      <v-col
                        cols="12"
                        lg="1"
                        class="pb-0 text-right XS"
                      >
                        <v-checkbox
                          v-model="customerTypeModal.ALL"
                          label="Tất cả"
                          color="red"
                          hide-details
                          @change="changeTypeCustomer('')"
                        />
                      </v-col>
                      <v-col
                        cols="12"
                        lg="2"
                        class="pb-0 text-right XS"
                      >
                        <v-checkbox
                          v-model="customerTypeModal.KL"
                          label="Khách Lẻ"
                          color="red"
                          hide-details
                          @change="changeTypeCustomer('KL')"
                        />
                      </v-col>
                      <v-col
                        cols="12"
                        lg="2"
                        class="pb-0 text-right XS"
                      >
                        <v-checkbox
                          v-model="customerTypeModal.KS"
                          label="Khách Sỉ"
                          color="red"
                          hide-details
                          @change="changeTypeCustomer('KS')"
                        />
                      </v-col>
                      <v-col
                        cols="12"
                        lg="2"
                        class="pb-0 text-right XS"
                      >
                        <v-checkbox
                          v-model="customerTypeModal.CTV"
                          label="CTV"
                          color="red"
                          hide-details
                          @change="changeTypeCustomer('CTV')"
                        />
                      </v-col>
                      <v-col
                        cols="12"
                        lg="5"
                        class="pb-0 text-right XS"
                      >
                        <v-text-field
                          v-model="search"
                          label="Tìm kiếm"
                          class="mx-4 pt-5 ma-0 pb-2"
                          hide-details=""
                        />
                      </v-col>
                    </v-row>
                  </template>
                  <!-- body -->
                  <template v-slot:item.order_code="{ item }">
                    <router-link
                      v-slot="{ href, route, navigate, isActive, isExactActive }"
                      :to="{ name: 'CHI TIET SAN PHAM', params: { id: item.id }}"
                    >
                      <a
                        :href="href"
                        @click="navigate"
                      >{{ item.order_code }}</a>
                    </router-link>
                  </template>
                  <template
                    v-slot:item.delivery_status_code="{ item }"
                  >
                    <v-progress-linear
                      v-if="item.delivery_status_value > 0"
                      :value="item.delivery_status_value"
                      color="blue"
                      height="20"
                      striped
                    >
                      <span>
                        Đang VC
                      </span>
                    </v-progress-linear>
                    <v-progress-linear
                      v-else
                      value="0"
                      height="20"
                      striped
                    >
                      <span>
                        ĐH Mới
                      </span>
                    </v-progress-linear>
                  </template>
                  <template
                    v-slot:item.total="{ item }"
                  >
                    {{ formatPrice(item.total, 0) }}
                  </template>
                  <template
                    v-slot:item.id="{ item }"
                  >
                    <v-btn
                      color="primary"
                      class="mr-2"
                      width="100"
                      height="30"
                      @list-detail="orderDetailDialog(item)"
                      @click="orderDetailDialog(item)"
                    >
                      Chi Tiết
                      <v-icon right>
                        edit
                      </v-icon>
                    </v-btn>
                    <v-btn
                      color="warning"
                      dark
                      v-bind="attrs"
                      class="rounded-pill"
                      height="20px"
                      width="80px"
                      v-on="on"
                      @click="onlyPrint(item)"
                    >
                      In
                      <v-icon right>
                        print
                      </v-icon>
                    </v-btn>
                  </template>
                </v-data-table>
              </v-col>
            </v-row>
            <!-- end desktop -->

            <!-- mobile-->
            <v-row v-else>
              <v-row class="pa-1 ma-1 invisible cols">
                <v-col
                  sm="3"
                  class="pb-0 text-right"
                >
                  <v-checkbox
                    v-model="customerTypeModal.ALL"
                    label="All"
                    color="red"
                    hide-details
                    @change="changeTypeCustomer('')"
                  />
                </v-col>
                <v-col
                  sm="3"
                  class="pb-0 text-right"
                >
                  <v-checkbox
                    v-model="customerTypeModal.KL"
                    label="K-Lẻ"
                    color="red"
                    hide-details
                    @change="changeTypeCustomer('KL')"
                  />
                </v-col>
                <v-col
                  sm="3"
                  class="pb-0 text-right"
                >
                  <v-checkbox
                    v-model="customerTypeModal.KS"
                    label="K-Sỉ"
                    color="red"
                    hide-details
                    @change="changeTypeCustomer('KS')"
                  />
                </v-col>
                <v-col
                  sm="3"
                  class="pb-0 text-right"
                >
                  <v-checkbox
                    v-model="customerTypeModal.CTV"
                    label="CTV"
                    color="red"
                    hide-details
                    @change="changeTypeCustomer('CTV')"
                  />
                </v-col>
              </v-row>
              <v-col class="mt-0 pt-1 pa-1">
                <swipe-list
                  ref="list"
                  class="card"
                  :disabled="!enabled"
                  :items="orderList"
                  item-key="id"
                >
                  <template v-slot="{ item, index, revealLeft, revealRight, close }">
                    <div class="card-content">
                      <v-row>
                        <v-col
                          cols="3"
                          md="3"
                          class="pr-1 pt-2"
                        >
                          <v-img
                            width="80"
                            src="https://cf.shopee.vn/file/8add33398aa57b801cb8b05c87c8532d"
                          />
                        </v-col>
                        <v-col
                          cols="9"
                          md="9"
                          class="pt-1 pb-0"
                        >
                          <v-row>
                            <v-col
                              cols="12"
                              md="12"
                              class="pr-1 pt-1 pb-0"
                            >
                              <!-- style content how ever you like -->
                              <h4>{{ item.name_delivery }} ({{ item.order_code }})</h4>
                            </v-col>
                          </v-row>
                          <v-row>
                            <v-col
                              cols="12"
                              md="12"
                              class="pr-1 pt-1 pb-0"
                            >
                              <!-- style content how ever you like -->
                              <h4 color="red">
                                {{ formatPrice(item.total, 0) }}
                              </h4>
                            </v-col>
                          </v-row>

                          <v-row>
                            <v-col
                              cols="12"
                              md="12"
                              class="pr-1 pt-1 pb-0"
                            >
                              <!-- style content how ever you like -->
                              <h5 color="red">
                                {{ item.phone_delivery }}
                              </h5>
                            </v-col>
                          </v-row>

                          <v-row>
                            <v-col
                              cols="12"
                              md="12"
                              class="pr-1 pt-1 pb-0"
                            >
                              <!-- style content how ever you like -->
                              <h5 color="red">
                                {{ item.address_delivery }}
                              </h5>
                            </v-col>
                          </v-row>

                          <v-row>
                            <v-col
                              cols="5"
                              md="7"
                              class="pr-1 pt-1 pb-1"
                            >
                              <v-menu offset-y>
                                <template v-slot:activator="{ on, attrs }">
                                  <v-btn
                                    color="primary"
                                    dark
                                    v-bind="attrs"
                                    class="rounded-pill"
                                    height="20px"
                                    width="120px"
                                    v-on="on"
                                  >
                                    {{ getOrderSts_2(item.delivery_status_code) }}
                                  </v-btn>
                                </template>
                                <v-list>
                                  <v-list-item
                                    v-for="(item1, index) in items_process"
                                    :key="index"
                                  >
                                    <v-list-item-title @click="changeOrderStatus(item, item1)">
                                      {{ item1.title }}
                                    </v-list-item-title>
                                  </v-list-item>
                                </v-list>
                              </v-menu>
                            </v-col>
                            <v-col
                              cols="7"
                              md="7"
                              class="pr-1 pt-1 pb-1"
                            >
                              <v-btn
                                color="warning"
                                dark
                                v-bind="attrs"
                                class="rounded-pill"
                                height="20px"
                                width="80px"
                                v-on="on"
                                @click="onlyPrint(item)"
                              >
                                In
                              </v-btn>
                            </v-col>
                          </v-row>
                        </v-col>
                      </v-row>
                    </div>
                    <v-divider class="dark-gray" />
                  </template>
                  <!-- left swipe side template and v-slot:left="{ item }" is the item clearly -->
                  <!-- remove if you dont wanna have left swipe side  -->
                  <!-- right swipe side template and v-slot:right"{ item }" is the item clearly -->
                  <!-- remove if you dont wanna have right swipe side  -->
                  <template v-slot:right="{ item }">
                    <div class="swipeout-action gray">
                      <v-icon color="white">
                        mdi-cart-plus
                      </v-icon>
                      <!-- place icon here or what ever you want -->
                    </div>
                    <div
                      class="swipeout-action text-center red pa-4"
                      @click="confirmDeleteOrder(item)"
                    >
                      <v-icon color="white">
                        mdi-close
                      </v-icon>
                      <!-- place icon here or what ever you want -->
                      <!-- <i class="fa fa-heart"></i> -->
                    </div>
                  </template>
                  <template v-slot:empty>
                    <div>
                      <!-- change mockSwipeList to an empty array to see this slot in action  -->
                      list is empty ( filtered or just empty ) abc
                    </div>
                  </template>
                </swipe-list>
              </v-col>
            </v-row>
            <!-- end mobile-->
          </v-tab-item>
          <v-tab-item class="tab-item-list">
            CHỜ GIAO HÀNG
          </v-tab-item>
          <v-tab-item class="tab-item-list">
            CHỜ TTT
          </v-tab-item>
          <v-tab-item class="tab-item-list">
            TRẢ HÀNG
          </v-tab-item>
          <v-tab-item class="tab-item-list">
            HOÀN TẤT
          </v-tab-item>
        </v-tabs-items>
      </v-tabs>

      <!-- desktop -->

      <v-row>
        <addProduct
          ref="addProductDialog"
          :v-model="dialog"
          @refeshList="getListOrder"
        />
      </v-row>
      <v-row>
        <addStorage
          ref="addStorage"
          :v-model="dialogStorage"
          @refeshList="getListOrder"
        />
      </v-row>
      <v-row>
        <dialogConfirm
          ref="dialogConfirm"
          :v-model="dialogConfirm"
          :title="titleConfirm"
          :content="contentConfirm"
          @select-ok="deleteOrder()"
        />
      </v-row>

      <v-row>
        <dialogAlert
          ref="dialogAlert"
          :v-model="dialogAlert"
        />
      </v-row>

      <v-row>
        <snackbarNew
          ref="snackNotification"
          :v-model="snackbar"
        />
      </v-row>

      <v-row>
        <orderDetail
          ref="orderDetail"
          :v-model="orderDetail"
        />
      </v-row>
    </base-material-search-screen>
  </v-container>
</template>

<script>
  import axios from 'axios'
  import config from '../../config/config'
  import addProduct from '../sales/add-product'
  import addStorage from '../sales/add-storage'
  import dialogConfirm from '../dashboard/component/dialogConfirm'
  import dialogAlert from '../dashboard/component/dialogAlert'
  import snackbarNew from '../dashboard/component/snackbarNew'
  import orderDetail from '../sales/sale-order-detail'
  import { SwipeList, SwipeOut } from 'vue-swipe-actions'
  import 'vue-swipe-actions/dist/vue-swipe-actions.css'

  export default {
    layout: 'SaleStorage',
    components: {
      // materialCard,
      // ProgressBar,
      addProduct,
      addStorage,
      dialogConfirm,
      dialogAlert,
      snackbarNew,
      orderDetail,
      SwipeOut,
      SwipeList,
    // VueEllipseProgress
    },
    props: {},
    data () {
      return {
        enabled: true,
        search: '',
        dialog: false,
        singleSelect: false,
        selected: [],
        dialogStorage: false,
        dialogConfirm: false,
        dialogAlert: false,
        pageCount: 0,
        itemPerPage: 5,
        bankList: [],
        orderList: [],
        order_customer_type: 'KL',
        knowledge: 30,
        orderDetail: false,
        show: false,
        color: null,
        colors: ['purple', 'info', 'success', 'warning', 'error'],
        top: true,
        bottom: false,
        left: false,
        right: false,
        snackbar: false,
        titleConfirm: 'Xác nhận',
        contentConfirm: 'Bạn có chắc chắn muốn xóa đơn hàng này không?',
        saleOrder: {
          order_customer_type: 'KL',
        },
        customerTypeModal: {
          ALL: false,
          KS: false,
          KL: false,
          CTV: false,
        },
        snackbarContent:
          'Đã có lỗi hệ thống xảy ra, vui lòng kiểm tra lại hoặc liên hệ với admin!!!',
        pagination: {
          ascending: true,
          sortBy: 'name',
          rowsPerPage: 10,
          page: 1,
        },
        headers: [
          {
            text: 'MÃ ĐH',
            sortable: false,
            value: 'order_code',
            width: '70px',
            format: (v) => v && String(v),
          },
          {
            text: 'TÊN KH',
            sortable: false,
            value: 'name_delivery',
            align: 'center',
          },
          {
            text: 'ĐIỆN THOẠI',
            sortable: false,
            value: 'phone_delivery',
          },
          {
            text: 'TỔNG TIỀN',
            sortable: false,
            value: 'total',
            align: 'right',
            format: (v) => v && Number(v).toFixed(2),
          },
          {
            text: 'ĐỊA CHỈ GIAO HÀNG',
            sortable: false,
            value: 'address_delivery',
          },
          {
            text: 'TRẠNG THÁI ĐH',
            sortable: false,
            value: 'delivery_status_code',
          },
          {
            text: 'Mã VĐ',
            value: 'delivery_tracking',
            align: 'left',
          },
          {
            text: 'GHI CHÚ',
            value: 'note',
            align: 'right',
          },
          {
            text: 'Sản Phẩm',
            sortable: false,
            align: 'center',
            value: 'id',
          },
        ],
        items: [],
        itemDetail: [],
        orderSelected: [],
        /*
        TRANG THAI DON HANG
        NEW: ĐĂNG KÝ VẬN VC - ĐÃ CÓ MÃ VẬN ĐƠN
        PROCESS: ĐANG VC
        RTG: TRẢ HÀNG
        DONE: GIAO HÀNG THÀNH CÔNG
        FINISHED: ĐƠN HOÀN THÀNH - TIỀN ĐÃ VỀ`
        */
        items_process: [
          { code: 'NEW', title: 'Chờ đóng gói' },
          { code: 'PROCESS', title: 'Chờ giao hàng' },
          { code: 'DONE', title: 'Chờ thanh toán' },
          { code: 'RTG', title: 'Trả hàng' },
          { code: 'FINISHED', title: 'Hoàn tất' },
        ],
        tab: null,
        tab_confirm_disabled: true,
        tabs: [
          { code: 'NEW', title: 'Chờ đóng gói', icon: 'mdi-account-outline', index: 0 },
          { code: 'PROCESS', title: 'Chờ giao hàng', icon: 'mdi-account-outline', index: 1 },
          { code: 'DONE', title: 'Chờ thanh toán', icon: 'mdi-account-outline', index: 2 },
          { code: 'RTG', title: 'Trả hàng', icon: 'mdi-account-outline', index: 3 },
          { code: 'FINISHED', title: 'Hoàn tất', icon: 'mdi-account-outline', index: 4 },

        ],
      }
    },
    computed: {
    //   ...bankState("bank", {
    //     bankList: "bankList",
    // })
    }, // end method
    created () {
      this.getListOrder()
    },
    methods: {
      isMobile () {
        if (/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
          return true
        } else {
          return false
        }
      },
      createOrder () {
        this.$router.push({ name: 'Bán hàng' })
      },
      async getListOrder () {
        const self = this
        console.log('getListOrder')
        console.log(this.saleOrder)

        var orderType = []
        if (!this.customerTypeModal.ALL) {
          if (this.customerTypeModal.KS) {
            orderType.push("'KS'")
          }
          if (this.customerTypeModal.KL) {
            orderType.push("'KL'")
          }
          if (this.customerTypeModal.CTV) {
            orderType.push("'CTV'")
          }
        } else {
          orderType.push("'KL'")
          orderType.push("'KS'")
          orderType.push("'CTV'")
        }
        console.log(orderType.toString())
        this.saleOrder.order_customer_type = orderType.join()
        await axios
          .post(config.API_FAMILY + '/api/selectOrders', this.saleOrder)
          .then(function (response) {
            self.orderList = response.data.data
            console.log(JSON.stringify(self.orderList))
          })
      },
      confirmDeleteOrder (detail) {
        // this.$refs.dialogConfirm.title = 'Xác nhận'
        // this.$refs.dialogConfirm.text = 'Bạn có chắc chắn muốn xóa đơn hàng này không?'
        if (detail != undefined && detail != null) {
          this.orderSelected = detail
        }
        this.$refs.dialogConfirm.dialog = true
      },

      async deleteOrder () {
        let itemDelete = this.selected
        if (this.isMobile()) {
          if (this.orderSelected != undefined && this.orderSelected != null) {
            itemDelete = this.orderSelected
          }
        }

        console.log('a')
        console.log(itemDelete)
        if (itemDelete !== undefined && itemDelete != null) {
          const seft = this
          const jsonReq = JSON.stringify(itemDelete)

          await axios
            .post(config.API_FAMILY + '/api/delOrders', JSON.parse(jsonReq))
            .then(function (response) {
              console.log('succuess')
              var data = response.data.data
              if (data !== undefined && data != null) {
              }
              seft.getListOrder()
              seft.$refs.dialogConfirm.dialog = false
            }).catch((error) => {
              console.log(error)
            })
        }
      },
      async onTabChange (clickedTab) {
        await this.$emit('onOrderTab', clickedTab)
        this.currentTab = clickedTab
        await this.$nextTick()
        if (!this.allowTabChange) this.currentTab = this.previousTab
        else this.previousTab = this.currentTab
        // TO GET TAB DATA OF CLICKED AND CURRENT TAB
        this.currentTabObject = this.tabs[this.currentTab]
        this.selectedTabObject = this.tabs[clickedTab]
        // console.log("onTabCHange");
        console.log('clickedTab', clickedTab)
        this.tabs[3].disabled = !this.validateBiz()
      },
      updateOrder () {

      },
      formatPrice (value, tofix) {
        const val = (value / 1).toFixed(tofix).replace(',', '.')
        return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',')
      },
      async orderDetailDialog (item) {
        // Get code
        const productCode = 'SP'
        // this.$refs.addProductDialog.productModel = null;
        // this.$refs.addProductDialog.resetValid();
        const self = this

        await axios
          .get(config.API_FAMILY + '/api/selectOrderDetail/' + item.id)
          .then(function (response) {
            self.itemDetail = response.data.data
          })
        console.log('Detail')
        console.log(JSON.stringify(self.itemDetail))
        if (self.itemDetail != undefined && self.itemDetail.length > 0) {
          this.$refs.orderDetail.saleOrderDetail = self.itemDetail
          self.$refs.orderDetail.dialog = true
        } else {
          this.snackbaralert(this.colors[4], 'KHÔNG CÓ SẢN PHẨM TRONG ĐƠN HÀNG NÀY')
        }
      },

      snackbaralert (...args) {
        if (args === undefined || args < 3) {
          this.$refs.snackNotification.color = this.colors[4]
          this.$refs.snackNotification.snackbarContent =
            'Đã có lỗi xảy ra, vui lòng liên hệ admin'
          this.$refs.snackNotification.snackbar = true
        } else {
          this.$refs.snackNotification.color = args[0]
          this.$refs.snackNotification.snackbarContent = args[1]
          this.$refs.snackNotification.snackbar = true
        }
      },
      changeTypeCustomer (sts) {
        this.saleOrder.order_customer_type = sts
        this.getListOrder(sts)
      },
      changeOrderStatus (itemOrder, status) {
        console.log('changeOrderStatus', status)
        for (var i = 0; i < this.orderList.length; i++) {
          if (this.orderList[i].id == itemOrder.id) {
            this.orderList[i].delivery_status_code = status.code
            console.log('idx', this.orderList[i])
          }
        }
        // let _order = this.orderList.filter(function(item) {
        //    console.log("idx");
        //   if (item.id == itemOrder.id){
        //     item.payment_info.info = status;

        //   }
        // });
        // console.log(_order);
        console.log(status)
      },
      async onlyPrint (item) {
        const fileID = item.order_code
        await axios
          .get(config.API_FAMILY + `/api/onlyPrint/${fileID}`)
          .then(function (response) {
            if (response.data.status == 'FAIL') {
              alert('Print thất bại, file không tồn tại')
            }
            console.log('onlyPrint', response)
          // seft.$router.push({ name: "DANH SÁCH ĐƠN HÀNG" });
          })
      },
      // Swipe
      revealFirstRight () {
        this.$refs.list.revealRight(0)
      },
      revealFirstLeft () {
        this.$refs.list.revealLeft(0)
      },
      closeFirst () {
        this.$refs.list.closeActions(0)
      },
      closeAll () {
        this.$refs.list.closeActions()
      },
      remove (item) {
        this.mockSwipeList = this.mockSwipeList.filter((i) => i !== item)
        // console.log(e, 'remove');
      },
      itemClick (e) {
        console.log(e, 'item click')
      },
      fbClick (e) {
        console.log(e, 'First Button Click')
      },
      sbClick (e) {
        console.log(e, 'Second Button Click')
      },

      // End Swipe
      // { code: 'NEW', title: 'Chờ đóng gói' }, 0
      // { code: 'PROCESS', title: 'Chờ giao hàng' }, 1
      // { code: 'DONE', title: 'Chờ thanh toán' }, 2
      // { code: 'RTG', title: 'Trả hàng' }, 3
      // { code: 'FINISHED', title: 'Hoàn tất' }, 4
      getOrderSts (key) {
        if (key == 'NEW') {
          return 0
        } else if (key == 'PROCESS') {
          return 1
        } else if (key == 'DONE') {
          return 2
        } else if (key == 'RTG') {
          return 3
        } else if (key == 'FINISHED') {
          return 4
        }
      },
      getOrderSts_2 (key) {
        if (key == 'NEW') {
          return 'Chờ đóng gói'
        } else if (key == 'PROCESS') {
          return 'Chờ giao hàng'
        } else if (key == 'DONE') {
          return 'Chờ thanh toán'
        } else if (key == 'RTG') {
          return 'Trả hàng'
        } else if (key == 'FINISHED') {
          return 'Hoàn tất'
        }
      },
    },

  }
</script>
<style scroped>
.text-right {
  text-align: right;
}
.text-center {
  text-align: center;
}
table tr td {
  padding: 0 8px !important;
}

.table-list table thead tr th {
  background-color: #2196f3 !important;
  color: #ffffff;
}
/* .table-list table {
  border-collapse: collapse !important;
  border: 1px solid gray !important;
} */
</style>
